package nc.impl.sc.m61.action.approve;

import nc.bs.pub.compiler.AbstractCompiler2;
import nc.bs.sc.plugin.SCOrderPluginPoint;
import nc.bs.scmpub.pf.PfParameterUtil;
import nc.impl.pubapp.pattern.data.bill.BillUpdate;
import nc.impl.pubapp.pattern.rule.processer.CompareAroundProcesser;
import nc.impl.sc.m61.action.approve.rule.ApproveStatusChkRule;
import nc.impl.sc.m61.action.approve.rule.SupplierFrozeChkRule;
import nc.impl.sc.m61.action.approve.rule.UpdatePFlowInfoRule;
import nc.itf.sc.reference.ic.ATPServices;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.sc.m61.entity.SCOrderVO;
import nc.vo.sc.m61.entity.context.SCOrderContxt;
import nc.vo.scmpub.res.billtype.SCBillType;
import org.apache.commons.lang.ArrayUtils;

public class SCOrderApproveAction {
	public SCOrderVO[] approve(SCOrderVO[] vos, SCOrderContxt contxt, AbstractCompiler2 script) {
		if (ArrayUtils.isEmpty(vos)) {
			return vos;
		} else {
			PfParameterUtil<SCOrderVO> util = new PfParameterUtil(script == null ? null : script.getPfParameterVO(),
					vos);
			SCOrderVO[] originBills = (SCOrderVO[]) util.getOrginBills();
			SCOrderVO[] clientBills = (SCOrderVO[]) util.getClientFullInfoBill();
			CompareAroundProcesser<SCOrderVO> prcr = new CompareAroundProcesser(SCOrderPluginPoint.APPROVE);
			this.addRule(prcr);
			prcr.before(clientBills, originBills);
			if (null != script) {
				try {
					script.procFlowBacth(script.getPfParameterVO());
				} catch (Exception var10) {
					ExceptionUtils.wrappException(var10);
				}
			}

			this.atpBeforeUpdate(clientBills);
			prcr.after(clientBills, originBills);
			BillUpdate<SCOrderVO> update = new BillUpdate();
			SCOrderVO[] updateVOs = (SCOrderVO[]) update.update(clientBills, originBills);
			this.atpAfterUpdate(updateVOs);
			return updateVOs;
		}
	}

	private void addRule(CompareAroundProcesser<SCOrderVO> prcr) {
		prcr.addBeforeFinalRule(new ApproveStatusChkRule());
		prcr.addBeforeFinalRule(new SupplierFrozeChkRule());
		prcr.addAfterFinalRule(new UpdatePFlowInfoRule());
	}

	private void atpAfterUpdate(SCOrderVO[] updateVOs) {
		ATPServices.modifyATPAfter(SCBillType.Order.getCode(), updateVOs);
	}

	private void atpBeforeUpdate(SCOrderVO[] clientBills) {
		ATPServices.modifyATPBefore(SCBillType.Order.getCode(), clientBills);
	}
}