package nc.bs.mmpac.wr.pfxx.plugin;

import java.text.SimpleDateFormat;
import java.util.Date;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.pfxx.ISwapContext;
import nc.bs.pfxx.plugin.AbstractPfxxPlugin;
import nc.itf.mmpac.wr.IWrMaintainService;
import nc.itf.uap.pf.IPFBusiAction;
import nc.ui.fa.newasset.view.newasset_config;
import nc.vo.mmpac.wr.entity.AggWrVO;
import nc.vo.pfxx.auxiliary.AggxsysregisterVO;
import nc.vo.pfxx.util.PfxxPluginUtils;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.pf.workflow.IPFActionName;
import nc.vo.pubapp.pattern.pub.PubAppTool;

public class MMPacWrPfxxPlugin extends AbstractPfxxPlugin {
	private IWrMaintainService service = null;

	public IWrMaintainService getMaintainService() {
		if (this.service == null) {
			this.service = (IWrMaintainService) NCLocator.getInstance().lookup(IWrMaintainService.class);
		}

		return this.service;
	}

	protected Object processBill(Object vo, ISwapContext swapContext, AggxsysregisterVO aggxsysvo)
			throws BusinessException {
		AggregatedValueObject resvo = (AggregatedValueObject) vo;
		try {
			// ߳ҵ
			SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			Object dateTimeString  = resvo.getParentVO().getAttributeValue("dbilldate");
			if(dateTimeString != null) {
				Date date = format.parse(dateTimeString.toString());
				long timestamp = date.getTime();
				InvocationInfoProxy.getInstance().setBizDateTime(timestamp);
			}
		} catch (Exception e) {
			throw new BusinessException("ʱתʧ!");
		}
		String vopk = PfxxPluginUtils.queryBillPKBeforeSaveOrUpdate(swapContext.getBilltype(), swapContext.getDocID());
		AggregatedValueObject returnVO = null;
		IPFBusiAction iPFBusiAction = NCLocator.getInstance().lookup(IPFBusiAction.class);
		if (PubAppTool.isNull(vopk)) {
			resvo.getParentVO().setStatus(2);
			CircularlyAccessibleValueObject[] arr$ = resvo.getChildrenVO();
			int len$ = arr$.length;

			for (int i$ = 0; i$ < len$; ++i$) {
				CircularlyAccessibleValueObject bvo = arr$[i$];
				bvo.setStatus(2);
			}
			returnVO = this.getMaintainService().insert(new AggWrVO[]{(AggWrVO) resvo})[0];
			//2022-11-11 yaoy 
			returnVO.getParentVO().setAttributeValue("fbillstatus", 2);
			this.getMaintainService().audit(new AggWrVO[] {(AggWrVO) returnVO});
		} else {
			returnVO = this.getMaintainService().update(new AggWrVO[]{(AggWrVO) resvo})[0];
		}

		vopk = returnVO.getParentVO().getPrimaryKey();
		PfxxPluginUtils.addDocIDVsPKContrast(swapContext.getBilltype(), swapContext.getDocID(), vopk);
		return vopk;
	}
}