package nc.bs.pu.m21.pfxx;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import nc.vo.pu.m21.entity.PayPlanVO;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.pu.m21.maintain.OrderSaveBP;
import nc.bs.pu.m21.maintain.rule.SupplierFrozeChkRule;
import nc.bs.pu.m21.plugin.OrderPluginPoint;
import nc.bs.scmpub.pf.PfParameterUtil;
import nc.impl.pu.m21.action.OrderDeleteAction;
import nc.impl.pu.m21.action.rule.approve.ApproveAfterEventRule;
import nc.impl.pu.m21.action.rule.approve.ApproveBeforeEventRule;
import nc.impl.pu.m21.action.rule.approve.ApproveBudgetCtrlRule;
import nc.impl.pu.m21.action.rule.approve.ApproveSupplyRule;
import nc.impl.pu.m21.action.rule.approve.ApproveVOValidateRule;
import nc.impl.pu.m21.action.rule.approve.FillNcaninnumRule;
import nc.impl.pu.m21.action.rule.approve.FilterOrderByStatusRule;
import nc.impl.pu.m21.action.rule.approve.InsertPayPlanRule;
import nc.impl.pu.m21.action.rule.approve.InsertStatusOnWayRule;
import nc.impl.pubapp.pattern.data.bill.BillQuery;
import nc.impl.pubapp.pattern.rule.processer.AroundProcesser;
import nc.itf.scmpub.reference.uap.bd.vat.BuySellFlagEnum;
import nc.itf.scmpub.reference.uap.pf.PfServiceScmUtil;
import nc.itf.uap.pf.IPFBusiAction;
import nc.vo.pu.m21.context.OrderContext;
import nc.vo.pu.m21.entity.OrderHeaderVO;
import nc.vo.pu.m21.entity.OrderItemVO;
import nc.vo.pu.m21.entity.OrderVO;
import nc.vo.pu.m21.entity.StatusOnWayItemVO;
import nc.vo.pu.pfxx.plugins.AbstractPuPfxxPlugin;
import nc.vo.pu.pub.enumeration.POEnumBillStatus;
import nc.vo.pu.pub.enumeration.PuBusiLogActionCode;
import nc.vo.pu.pub.enumeration.PuBusiLogPathCode;
import nc.vo.pu.pub.rule.busilog.WriteOperateLogRule;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.ISuperVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.pf.workflow.IPFActionName;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.scmf.pub.util.BatchNCBaseTypeUtils;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.pubitf.bbd.CurrtypeQuery;
import nc.pubitf.pu.m21.api.IOrderMaintainAPI;

import org.apache.commons.lang.ArrayUtils;

import nc.itf.uap.IVOPersistence;

/**
 * @since 6.0
 * @version 2011-5-8 09:55:01
 * @author wuxla
 */

public class M21PfxxPlugin extends AbstractPuPfxxPlugin {
	private BaseDAO basedao_nc = null;
	private BaseDAO getncbbasedao() {
		if (basedao_nc == null) {
			basedao_nc = new BaseDAO("design");
		}
		return basedao_nc;
	}
	private IVOPersistence IVOPersistence = (IVOPersistence) NCLocator.getInstance().lookup(IVOPersistence.class);
	private void checkMny(AggregatedValueObject vo) {
		StringBuilder errrows = new StringBuilder();
		OrderItemVO[] bodyvos = ((OrderVO) vo).getBVO();
		for (OrderItemVO orderItemVO : bodyvos) {
			Integer fbuysellflag = orderItemVO.getFbuysellflag();
			// ˰
			UFDouble nmny = orderItemVO.getNmny();
			// ˰ϼ
			UFDouble ntaxmny = orderItemVO.getNtaxmny();
			// ˰
			UFDouble ntax = orderItemVO.getNtax();
			// ڲɹ
			if (BuySellFlagEnum.IMPORT.value().equals(fbuysellflag)) {
				if (!nmny.equals(ntaxmny)) {
					errrows.append(orderItemVO.getCrowno() + ",");
				}
			}
			// ڲɹ
			else if (BuySellFlagEnum.NATIONAL_BUY.value().equals(fbuysellflag)) {
				if (!nmny.add(ntax).equals(ntaxmny)) {
					errrows.append(orderItemVO.getCrowno() + ",");
				}
			} else {
				ExceptionUtils.wrappBusinessException(nc.vo.ml.NCLangRes4VoTransl
						.getNCLangRes().getStrByID("4004000_0", "04004000-0139", null,
								new String[] { orderItemVO.getCrowno() })/*
																													 * @res
																													 * ":{0}ɹ幺òȷ"
																													 */);
			}
		}
		if (errrows.length() <= 0) {
			return;
		}
		errrows.deleteCharAt(errrows.length() - 1);
		ExceptionUtils.wrappBusinessException(nc.vo.ml.NCLangRes4VoTransl
				.getNCLangRes().getStrByID("4004000_0", "04004000-0137", null,
						new String[] { errrows.toString() })/*
																								 * @res
																								 * "{0}˰˰˰ϼƼϵ󲻿ɵ룡"
																								 */);
	}

	/**
	 * λдϢĵݿƲɵ
	 * 
	 * @param vo
	 */
	private void checkRwite(AggregatedValueObject vo) {
		OrderItemVO[] bodyvos = ((OrderVO) vo).getBVO();
		for (OrderItemVO orderItemVO : bodyvos) {
			StringBuilder errstr = new StringBuilder();
			// ۼѺҿƱ
			UFDouble nacccancelinvmny = orderItemVO.getNacccancelinvmny();
			if (!BatchNCBaseTypeUtils.isNullOrZero(nacccancelinvmny)) {
				errstr.append(OrderItemVO.NACCCANCELINVMNY + ",");
			}
			// ۼƱҿƱ
			UFDouble naccuminvoicemny = orderItemVO.getNaccuminvoicemny();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccuminvoicemny)) {
				errstr.append(OrderItemVO.NACCUMINVOICEMNY + ",");
			}
			// ۼƿƱ
			UFDouble nfeemny = orderItemVO.getNfeemny();
			if (!BatchNCBaseTypeUtils.isNullOrZero(nfeemny)) {
				errstr.append(OrderItemVO.NFEEMNY + ",");
			}

			// ۼƵ
			UFDouble naccumarrvnum = orderItemVO.getNaccumarrvnum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccumarrvnum)) {
				errstr.append(OrderItemVO.NACCUMARRVNUM + ",");
			}
			// ۼ
			UFDouble naccumstorenum = orderItemVO.getNaccumstorenum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccumstorenum)) {
				errstr.append(OrderItemVO.NACCUMSTORENUM + ",");
			}
			// ۼƿƱ
			UFDouble naccuminvoicenum = orderItemVO.getNaccuminvoicenum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccuminvoicenum)) {
				errstr.append(OrderItemVO.NACCUMINVOICENUM + ",");
			}
			// ۼ;
			UFDouble naccumwastnum = orderItemVO.getNaccumwastnum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccumwastnum)) {
				errstr.append(OrderItemVO.NACCUMWASTNUM + ",");
			}
			// ۼƵƻ
			UFDouble naccumrpnum = orderItemVO.getNaccumrpnum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccumrpnum)) {
				errstr.append(OrderItemVO.NACCUMRPNUM + ",");
			}
			// ۼ
			UFDouble naccumdevnum = orderItemVO.getNaccumdevnum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(naccumdevnum)) {
				errstr.append(OrderItemVO.NACCUMDEVNUM + ",");
			}

			// ۼ˻
			UFDouble nbackarrvnum = orderItemVO.getNbackarrvnum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(nbackarrvnum)) {
				errstr.append(OrderItemVO.NBACKARRVNUM + ",");
			}
			// ۼ˿
			UFDouble nbackstorenum = orderItemVO.getNbackstorenum();
			if (!BatchNCBaseTypeUtils.isNullOrZero(nbackstorenum)) {
				errstr.append(OrderItemVO.NBACKSTORENUM + ",");
			}

			if (errstr.length() <= 0) {
				return;
			}
			errstr.deleteCharAt(errstr.length() - 1);
			ExceptionUtils.wrappBusinessException(nc.vo.ml.NCLangRes4VoTransl
					.getNCLangRes().getStrByID("4004000_0", "04004000-0138", null,
							new String[] { orderItemVO.getCrowno(), errstr.toString() })/*
																																					 * @res
																																					 * ":{0}ڻд[{1}],ɵ룡"
																																					 */);
		}
	}

	private AggregatedValueObject save(AggregatedValueObject updatevo,
			AggregatedValueObject origVO) {
		OrderVO[] returnVOs = new OrderSaveBP(new OrderContext()).save(
				new OrderVO[] { (OrderVO) updatevo },
				new OrderVO[] { (OrderVO) origVO });
		
		
		
	/*	IPFBusiAction service = NCLocator.getInstance().lookup(IPFBusiAction.class);
		try {
			returnVOs =(OrderVO[]) service.processAction("APPROVE",
				     "21", null, returnVOs[0], null, null);
		} catch (BusinessException e) {
			// TODO Զɵ catch 
			e.printStackTrace();
		}*/
		
	
			
	//	returnVOs=	(OrderVO[]) PfServiceScmUtil.processBatch("APPROVE", "21", returnVOs, null, null);
		
		
		
		return returnVOs[0];
	}

	/**
	 * voǷɵ
	 * 
	 * @param vo
	 */
	@Override
	protected void checkCanInster(AggregatedValueObject vo) {
		OrderVO order = (OrderVO) vo;
		int status = order.getHVO().getForderstatus();
		if (POEnumBillStatus.APPROVE.toInt() == status) {
			String approver = order.getHVO().getApprover();
			if (approver == null || approver.isEmpty()) {
				ExceptionUtils.wrappBusinessException("ʧܣ̬ݲûˣ");
			}
			UFDate ufDate = order.getHVO().getTaudittime();
			if (ufDate == null) {
				ExceptionUtils.wrappBusinessException("ʧܣ̬ڲΪգ");
			}
			this.checkMny(vo);
			// this.checkRwite(vo);
		} else {
			super.checkCanInster(vo);
			this.checkMny(vo);
			this.checkRwite(vo);
		}
	}

	@Override
	protected void deleteVO(AggregatedValueObject vo) {
		new OrderDeleteAction().delete(new OrderVO[] { (OrderVO) vo }, null);
	}

	@Override
	protected String getBillStatusKey() {
		return OrderHeaderVO.FORDERSTATUS;
	}

	@Override
	protected String getChildrenPkFiled() {
		return OrderItemVO.PK_ORDER_B;
	}

	@Override
	protected String getParentPkFiled() {
		return OrderHeaderVO.PK_ORDER;
	}

	@Override
	protected AggregatedValueObject insert(AggregatedValueObject vo) {
		if (vo != null) {
			this.checkCanInster(vo);
		}
		OrderVO order = (OrderVO) vo;
		
		
		try {
			// ߳ҵ
			SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			Object dateTimeString  = vo.getParentVO().getAttributeValue("dbilldate");
			if(dateTimeString != null) {
				Date date = format.parse(dateTimeString.toString());
				long timestamp = date.getTime();
				InvocationInfoProxy.getInstance().setBizDateTime(timestamp);
			}
		} catch (Exception e) {
			ExceptionUtils.wrappException(e);
		}
		int status = order.getHVO().getForderstatus();
		if (POEnumBillStatus.APPROVE.toInt() == status) {
			OrderHeaderVO hvo = order.getHVO();
			String approver = hvo.getApprover();
			//hvo.setApprover(null);
			//hvo.setForderstatus(POEnumBillStatus.FREE.toInt());
			//UFDate taudittime = hvo.getTaudittime();
		    //hvo.setTaudittime(null);
	        //AggregatedValueObject save = this.save(vo, null);			
			
			OrderVO[] aggvos= {order} ;
			IPFBusiAction service = NCLocator.getInstance().lookup(IPFBusiAction.class);
			OrderVO[] ordervos = null;
			try {
				ordervos = (OrderVO[]) service.processAction("SAVEBASE",
					     "21", null, aggvos[0], null, null);
			} catch (BusinessException e1) {
				// TODO Զɵ catch 
				e1.printStackTrace();
				ExceptionUtils.wrappException(e1);
			}	
			OrderVO	orderVO = ordervos[0];
			PayPlanVO view=new PayPlanVO();
			OrderHeaderVO vo2=orderVO.getHVO();
			view.setPk_order(vo2.getPk_order());
			view.setPk_group(vo2.getPk_group());
			view.setNmny(vo2.getNtotalorigmny());
			view.setNorigmny(vo2.getNtotalorigmny());
			view.setNexchangerate(new UFDouble(1));
			view.setNtotalorigmny(vo2.getNtotalorigmny());
			view.setPk_financeorg(vo2.getPk_org());
			view.setPk_financeorg_v(vo2.getPk_org_v());
			view.setNrate(new UFDouble(100));
			view.setIsdeposit(new UFBoolean(false));
			view.setBpreflag(new UFBoolean(false));
			view.setDr(0);
			view.setCrowno("10");
			view.setCcurrencyid(vo2.getCorigcurrencyid());
			view.setCorigcurrencyid(vo2.getCorigcurrencyid());
		
			OrderItemVO[] bodyvos =(OrderItemVO []) orderVO.getChildren(OrderItemVO .class);
			List<StatusOnWayItemVO> listatusOn=new ArrayList<>();
			for(OrderItemVO bodyvo:bodyvos){
				StatusOnWayItemVO  statonvo=new StatusOnWayItemVO ();
				statonvo.setPk_group(vo2.getPk_group());
				statonvo.setPk_org(vo2.getPk_org());
				statonvo.setPk_org_v(vo2.getPk_org_v());
				statonvo.setPk_order(vo2.getPk_order());
				statonvo.setPk_order_b(bodyvo.getPk_order_b());
				statonvo.setDr(0);
				statonvo.setFonwaystatus(8);
				statonvo.setIsoperated(UFBoolean.FALSE);
				statonvo.setNmaxhandlenum(vo2.getNtotalastnum() );
				statonvo.setNonwaynum(vo2.getNtotalastnum() );
				listatusOn.add(statonvo);
			}		
	/*		PayPlanVO[] payvo=(PayPlanVO[]) aggvo.getChildren(PayPlanVO.class);
			OrderItemVO[] ordervo =(OrderItemVO []) aggvo.getChildren(OrderItemVO .class);
			if(payvo==null||payvo.length==0){
				payvo=new PayPlanVO[1];
				payvo[0]=view;
			}
			aggvo.setChildren(PayPlanVO.class, payvo);
			save=aggvo;*/
			try {			
				IVOPersistence.insertVO(view);
				IVOPersistence.insertVOList(listatusOn);				
			} catch (BusinessException e) {
				// TODO Զɵ catch 
				e.printStackTrace();
				ExceptionUtils.wrappException(e);
			}			
		//	OrderVO orderVO = this.approve(save, approver, taudittime);
			return orderVO;
		}
		return this.save(vo, null);
	}

	private OrderVO approve(AggregatedValueObject vo, String approver,
			UFDate taudittime) {
		AroundProcesser<OrderVO> processer = new AroundProcesser<OrderVO>(
				OrderPluginPoint.APPROVE);
		OrderVO order = (OrderVO) vo;
		this.addBeforeRule(processer);
		this.addAfterRule(processer);
		// ǰ
		processer.before(new OrderVO[] { order });
		OrderHeaderVO hvo = order.getHVO();
		hvo.setApprover(approver);
		hvo.setForderstatus(POEnumBillStatus.APPROVE.toInt());
		hvo.setTaudittime(taudittime);
		processer.after(new OrderVO[] { order });
		return order;
	}

	private void addBeforeRule(AroundProcesser<OrderVO> processer) {
		// VO״̬
		processer.addBeforeRule(new ApproveVOValidateRule());
		// Ӧ̶
		processer.addBeforeRule(new SupplierFrozeChkRule());
		// ǰ¼
		processer.addBeforeRule(new ApproveBeforeEventRule());
	}

	private void addAfterRule(AroundProcesser<OrderVO> processer) {
		// дҵ־ҪŵFilterOrderByStatusRuleǰ棬voпܻᱻ˵û¼־
		processer.addAfterRule(new WriteOperateLogRule<OrderVO>(
				PuBusiLogPathCode.orderApprovePath.getCode(),
				PuBusiLogActionCode.approve.getCode()));

		processer.addAfterRule(new FilterOrderByStatusRule(POEnumBillStatus.APPROVE
				.toInt()));
		processer.addAfterRule(new ApproveSupplyRule());
		// ɹƻ
		processer.addAfterRule(new ApproveBudgetCtrlRule());
		// ;״̬в
		processer.addAfterRule(new InsertStatusOnWayRule());
		processer.addAfterRule(new InsertPayPlanRule());
		// ÿΪ˺ֱⵥṩ֧
		processer.addAfterRule(new FillNcaninnumRule());
		// ¼
		processer.addAfterRule(new ApproveAfterEventRule());
	}

	@Override
	protected AggregatedValueObject queryVOByPk(String voPk) {
		BillQuery<OrderVO> billquery = new BillQuery<OrderVO>(OrderVO.class);
		OrderVO[] vos = billquery.query(new String[] { voPk });

		if (ArrayUtils.isEmpty(vos)) {
			return null;
		}
		return vos[0];
	}

	@Override
	protected AggregatedValueObject update(AggregatedValueObject updatevo,
			AggregatedValueObject origVO) {
		return this.save(updatevo, origVO);
	}

}
