package nc.bs.xh.impl;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.scmpub.pf.PfParameterUtil;
import nc.bs.servlet.service.BaseServlet;
import nc.itf.ic.m4n.ITransformMaitain;
import nc.itf.pu.m21.IOrderMaintain;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IPFBusiAction;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.log.NcLog;
import nc.vo.ic.m4n.entity.TransformHeadVO;
import nc.vo.ic.m4n.entity.TransformVO;
import nc.vo.mmsfc.operationrep.entity.OprepItemVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFDouble;
import nc.vo.util.CloneUtil;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import nc.vo.ic.m4n.entity.TransformBodyVO;


public class TransformAddImpl extends BaseServlet implements IHttpServletAdaptor{
	
	IUAPQueryBS iuap= (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		// TODO Auto-generated method stub
		InvocationInfoProxy.getInstance().setUserDataSource("nc65");
		NCLocator.getInstance().lookup(ISecurityTokenCallback.class).token("NCSystem".getBytes(),"pfxx".getBytes());
        try {
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSONObject.fromObject(createStr);
			String vbillcode = "";
			PrintWriter out = resp.getWriter();
			vbillcode = json.getString("vbillcode");
			checkJson(json);//ǿж
			try {
				// ߳ҵ
				SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
				Object dateTimeString  = json.getString("dbilldate");
				if(dateTimeString != null) {
					Date date = format.parse(dateTimeString.toString());
					long timestamp = date.getTime();
					InvocationInfoProxy.getInstance().setBizDateTime(timestamp);
				}
			} catch (Exception e) {
				throw new BusinessException("ʱתʧ!");
			}
			InvocationInfoProxy.getInstance().setGroupId(SqlexecuteQuery("pk_group", "org_group", "code", json.getString("pk_group")));
			InvocationInfoProxy.getInstance().setUserId(SqlexecuteQuery("cuserid", "sm_user", "user_code", json.getString("creator")));
			
			TransformVO[] transformvos = new TransformVO[1];
			TransformVO transformvo = new TransformVO();
			transformvos[0] = transformvo;
			TransformHeadVO transformheadvo = new TransformHeadVO();
			TransformBodyVO[] transformbodyvos = new TransformBodyVO[json.getJSONArray("cspecialbid").size()];
			
			/**
			 * װͷVO
			 */
			transformheadvo.setVbillcode(vbillcode);
			transformheadvo.setPk_group(SqlexecuteQuery("pk_group", "org_group", "code", json.getString("pk_group")));
			transformheadvo.setPk_org(SqlexecuteQuery("pk_stockorg", "org_stockorg", "code", json.getString("pk_org")));
			transformheadvo.setPk_org_v(SqlexecuteQuery("pk_vid", "org_stockorg_v", "code", json.getString("pk_org")));
			transformheadvo.setCorpoid(SqlexecuteQuery("pk_corp", "org_corp", "code", json.getString("corpoid")));
			transformheadvo.setCorpvid(SqlexecuteQuery("pk_vid", "org_corp", "code", json.getString("corpoid")));
			transformheadvo.setDbilldate(new UFDate(json.getString("dbilldate")));
			transformheadvo.setVtrantypecode(json.getString("vtrantypecode"));
			transformheadvo.setCreator(SqlexecuteQuery("cuserid", "sm_user", "user_code", json.getString("creator")));
			transformheadvo.setCreationtime(new UFDateTime(json.getString("dbilldate")));
			transformheadvo.setBillmaker(SqlexecuteQuery("cuserid", "sm_user", "user_code", json.getString("creator")));
			transformheadvo.setDmakedate(new UFDate(json.getString("dbilldate")));
			transformheadvo.setCtrantypeid(QueryTrantype(json.getString("vtrantypecode"),SqlexecuteQuery("pk_group", "org_group", "code", json.getString("pk_group"))));
			transformvo.setParentVO(transformheadvo);
			
			/**
			 * װVO
			 */
			JSONArray bodyArray = json.getJSONArray("cspecialbid");
			int i=0;
			for (Object Object : bodyArray) {
				JSONObject bodyObject = JSONObject.fromObject(Object);
				TransformBodyVO transformbodyvo = new TransformBodyVO();
				transformbodyvo.setCrowno(bodyObject.getString("crowno"));
				transformbodyvo.setFbillrowflag(Integer.parseInt(bodyObject.getString("fbillrowflag")));
				transformbodyvo.setPk_group(SqlexecuteQuery("pk_group", "org_group", "code", bodyObject.getString("pk_group")));
				transformbodyvo.setPk_org(SqlexecuteQuery("pk_stockorg", "org_stockorg", "code", bodyObject.getString("pk_org")));
				transformbodyvo.setPk_org_v(SqlexecuteQuery("pk_vid", "org_stockorg_v", "code", bodyObject.getString("pk_org")));
				transformbodyvo.setCorpoid(SqlexecuteQuery("pk_corp", "org_corp", "code", bodyObject.getString("corpoid")));
				transformbodyvo.setCorpvid(SqlexecuteQuery("pk_vid", "org_corp", "code", bodyObject.getString("corpoid")));
				transformbodyvo.setCbodywarehouseid(SqlexecuteQuery("pk_stordoc", "bd_stordoc", "code", bodyObject.getString("cbodywarehouseid")));
				transformbodyvo.setCmaterialoid(SqlexecuteQuery("pk_source", "bd_material_v", "code", bodyObject.getString("cmaterialoid")));
				transformbodyvo.setCmaterialvid(SqlexecuteQuery("pk_material", "bd_material", "code", bodyObject.getString("cmaterialoid")));
				transformbodyvo.setCunitid(SqlexecuteQuery("pk_measdoc", "bd_measdoc", "code", bodyObject.getString("cunitid")));
				transformbodyvo.setCastunitid(SqlexecuteQuery("pk_measdoc", "bd_measdoc", "code", bodyObject.getString("castunitid")));
				transformbodyvo.setVchangerate(bodyObject.getString("vchangerate"));
				transformbodyvo.setNnum(new UFDouble(bodyObject.getString("nnum")));
				transformbodyvo.setNassistnum(new UFDouble(bodyObject.getString("nassistnum")));
				transformbodyvo.setNcostprice("".equals(bodyObject.getString("ncostprice")) ? null : new UFDouble(bodyObject.getString("ncostprice")));
				transformbodyvo.setNcostmny("".equals(bodyObject.getString("ncostmny")) ? null : new UFDouble(bodyObject.getString("ncostmny")));
				transformbodyvo.setVbatchcode(bodyObject.getString("vbatchcode"));
				transformbodyvos[i] = transformbodyvo;
				i++;
			}
			transformvo.setChildrenVO(transformbodyvos);
			
			ITransformMaitain itransform=(ITransformMaitain)NCLocator.getInstance().lookup(ITransformMaitain.class);
			itransform.insert(transformvos);
//			IPFBusiAction service = NCLocator.getInstance().lookup(IPFBusiAction.class);
//			HashMap<String, Object> pfparam = new HashMap<String, Object>(); // òڿԶʱť״̬ 
//			pfparam.put(PfParameterUtil.ORIGIN_VO_PARAMETER, CloneUtil.deepClone(transformvos[0]));
//			service.processAction("APPROVE",
//	                "4N", null, transformvos[0], null, pfparam);
			out.print(formatRSJsonData("ɹ","",vbillcode)); 
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			resp.getWriter().write(formatRSJsonData("ʧ",
				     e.getMessage().toString(),"").toString());
			StringWriter stringWriter = new StringWriter();
			e.printStackTrace(new PrintWriter(stringWriter));
			//ȡϸϢ
			String msg=stringWriter.getBuffer().toString();
			NcLog.info("ӿڷֵʾ:"+msg);
		}
        
	}
	
	/*
	 * ǿж
	 */
	private void checkJson(JSONObject json) throws Exception {
		
		StringBuffer mags = new StringBuffer();
		Boolean empty = true;
		
		String vbillcode = "vbillcode";//ݺ
		String group = "pk_group";//ű
		String creator = "creator";//
		
		String body = "cspecialbid";//
 
		String[] HeadKey = {vbillcode,group,creator};
		
		for (String as : HeadKey) {

			if (json.getString(as).isEmpty()) {
				empty = false;
				mags.append("'" + as + "'");
			}
		}
		
		if (json.getJSONArray(body)==null) {
			empty = false;
			mags.append("岻ڣ ");
		}
		
		JSONArray oprepObjectBs = json.getJSONArray("cspecialbid");
		
		if (oprepObjectBs == null || oprepObjectBs.size() == 0) {
			throw new Exception("ݲΪգ");
		}
		
		String cmaterialoid = "cmaterialoid";//ϱ
		
		for(int i = 0; i < oprepObjectBs.size(); i++) {
			
			JSONObject oprepJsonObjectB = oprepObjectBs.getJSONObject(i);
			String[] BodyKey = {cmaterialoid};
			int num = i+1;
			
			mags.append(""+num+"壺{");
			for (String as : BodyKey) {

				if (oprepJsonObjectB.getString(as).isEmpty()) {
					empty = false;
					mags.append("'" + as + "' ");
				}
			}
			mags.append("}");
		}
		
		if (!empty) {
			throw new Exception("ֶβΪգ"+mags);
		}
	}
	
	/*
	 * ݿѯ
	 */
	private String SqlexecuteQuery(String out,String table,String key,String value) throws Exception {
		
		String sql = "select "+out+" from "+table+" where "+key+" = '"+value+"' and nvl(dr,0)=0";
		
		Object object;
		try {
			object = iuap.executeQuery(sql, new ColumnProcessor());
			if (object==null) {
				throw new Exception("δѯݣ"+value+"Ƿȷ");
			}
			
			return object.toString();
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return e.getMessage();
		}
	}
	
	/*
	 * ѯתpk
	 */
	private String QueryTrantype(String code,String group) throws Exception {
		
		String sql = "select pk_billtypeid from bd_billtype where pk_billtypecode = '"+code+"' and pk_group = '"+group+"' and nvl(dr,0)=0";
		
		Object object;
		try {
			object = iuap.executeQuery(sql, new ColumnProcessor());
			if (object==null) {
				throw new Exception("δѯݣ"+code+"Ƿȷ");
			}
			
			return object.toString();
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return e.getMessage();
		}
	}

}
